﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace XDT_NLevelHeirarchy_SL4
{
    public partial class MainPage : UserControl
    {

        //the number of levels in the hierarchy
        private int treeDepth = 5;

        //the number of children of each node
        private SimpleNode viewModel;

        public MainPage()
        {
            InitializeComponent();
            Loaded += new RoutedEventHandler(MainPage_Loaded);
        }

        void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            viewModel = new SimpleNode(); //new SimpleNodeDataSource();
            DataContext = viewModel;//this.viewModel;

            this.LoadDataSource();
        }

        private void LoadDataSource()
        {
            viewModel.Children.Add(SetNodes(0));
            viewModel.Children.Add(SetNodes(0));
        }

        /// <summary>
        /// Recursively populate a tree structure
        /// </summary>
        /// <param name="nodes"></param>
        /// <param name="level"></param>
        private SimpleNode SetNodes(int level)
        {
            if (level == treeDepth)
                return null;
            SimpleNode sn = new SimpleNode();
            sn.Text = "Node " + (level + 1).ToString() + ":Level " + level.ToString();

            int templevel = ++level;
            SimpleNode t1 = SetNodes(templevel);
            SimpleNode t2 = SetNodes(templevel);

            if (t1 != null) sn.Children.Add(t1);
            if (t2 != null) sn.Children.Add(t2);

            sn.Displays.Add(new Display("D1"));
            sn.Displays.Add(new Display("D2"));

            return sn;
        }
    }
}
